﻿version
6.50
-1
2
strb:StringBuilder
stre:StringsEx
Sub designer
end sub
@EndOfDesignText@
Sub Globals
	'Declare the global variables here.

End Sub
Public Sub ParseSlashWiki (wiki)

'
' Slash syntax written by Don Graham
' Version 08.08.25
' updated: 08.09.02 - fixed /1/2/3/4/5/6 to check for preceding number ie a date, added new markup

 ErrorLabel(wikiParseError)
 'HtmStr = "<html><head><meta http-equiv=" & Chr(34) & "Content-Type" & Chr(34) & " content=" & Chr(34) & "text/html; charset=utf-8" & Chr(34) & ">" & crlf
 'HtmStr = HtmStr & "</head><body>" & crlf
 'Msgbox(wiki & crlf & StrLength(wiki))
 debugMode=True
 stre.New1
 
  HtmStr = "<html><head><meta http-equiv=" & Chr(34) & "Content-Type" & Chr(34) & " content=" & Chr(34) & "text/html; charset=utf-8" & Chr(34) & ">" & CRLF
  HtmStr = HtmStr & "<title>homepage</title>" & CRLF
  If cPPC = True Then
  ' Running on ppc
  If FileExist(Main.wikiDir & "wikistyle.css") = True Then
  FileOpen (c1, Main.wikiDir & "wikistyle.css", cRead ,, cASCII)
  css = FileReadToEnd(c1)
  FileClose (c1)
  HtmStr = HtmStr & "<style  TYPE=" & Chr(34) & "text/css" & Chr(34) & ">" & CRLF
  HtmStr = HtmStr & css & CRLF
  HtmStr = HtmStr & "</style>"
  End If
  Else
  ' running on desktop
 
   HtmStr = HtmStr & "<link rel=" & Chr(34) & "stylesheet" & Chr(34) & " href=" & Chr(34) & "file:///" & Main.wikiDir & "wikistyle.css" & Chr(34) & " type=" &Chr(34)&"text/css" & Chr(34) & ">" & CRLF 
  End If
  HtmStr = HtmStr & "</head><body>" & CRLF
   
 For x=0 To StrLength(wiki)
  If SubString(wiki,x,1)=Chr(13) Then 
   HtmStr=HtmStr & "<br>"
   x=x+1
  End If
  'If SubString(wiki,x,1)=" " Then
  '	HtmStr=HtmStr & "&nbsp;"
  '	x=x+1
  'End If
  
  
  ' msgbox(substring(wiki,x,1))
   If SubString(wiki,x,1)="/"   Then 'TODO: account for leading space
   		
	
   
   'Msgbox("found")
    wikiTag=SubString(wiki,x,2)
    'wikiTagStart=x
 
 '.13 
	If (x > 0 AND SubString(wiki,x-1,1)="<") OR SubString(wiki,x,1)="<" Then
			' this is html markup?
			HtmStr=HtmStr & SubString(wiki,x,StrIndexOf(wiki,">",x))
			x=StrIndexOf(wiki,">",x)
	Else
  '.13	
	
			Select wikiTag
			'These require a closing tag - closing tag must match opening tag
			Case "/." 'link
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/.",x+1)
			'Msgbox(wikiTagStart & " - " & wikiTagEnd)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			If StrIndexOf(wikiSubString,":",0) < 0 Then
			'simple link
			' HtmStr=HtmStr & "<a href='" & wikiSubString & "'>" & wikiSubString & "</a>"
			HtmStr=HtmStr & "<a href='about:" & wikiSubString & "'>" & wikiSubString & "</a>"
			Else
			'descriptive link
			leftSubString=SubString(wikiSubString,0,StrIndexOf(wikiSubString,":",0))
			
		
		rightSubString=SubString(wikiSubString,StrIndexOf(wikiSubString,":",0)+1,StrLength(wikiSubString)-StrIndexOf(wikiSubString,":",0))
			
			' HtmStr=HtmStr & "<a href='" & leftSubString & "'>" & rightSubString & "</a>"
			HtmStr=HtmStr & "<a href='about:" & stre.Trim(leftSubString) & "'>" & stre.Trim(rightSubString) & "</a>"
			
			End If
			
			Case "/b" 'bold <strong>
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/b",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<strong>" & WikiSubString & "</strong>"
			Case "/i" 'italic <em>
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/i",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<em>" & WikiSubString & "</em>"
			Case "/u" 'underline
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/u",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<u>" & WikiSubString & "</u>"
			Case "/s" 'striked <strike>
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/s",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<del>" & WikiSubString & "</del>"
			Case "/m" 'Mono
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/m",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<tt>" & WikiSubString & "</tt>"
			
			Case "/f" 'Fine/small print
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/f",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<small>" & WikiSubString & "</small>"
			
			Case "/g" 'Giant/big print
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/g",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<big>" & WikiSubString & "</big>"
			
			Case "/q" 'quote
			wikiTagStart=x
			WikiTagEnd=StrIndexOf(wiki,"/q",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<blockquote>" & WikiSubString & "</blockquote>"	
			
			
			Case "//" 'ignore
			
			strb.New1(50)
			wikiTagStart=x
			wikiTagEnd=StrIndexOf(wiki,"//",x+1)
			
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			'Msgbox(wikiSubString)
			'fixed 9/2/08: carriage returns
			strb.Append(WikiSubString)
			'Msgbox(strb.ToString)
			strb.Replace(CRLF, "<br>")
		'Msgbox(strb.ToString)
			WikiSubString=strb.ToString
			
			x=WikiTagEnd+1
			'x=x+ StrLength(WikiSubString)
			HtmStr=HtmStr & WikiSubString 
			
			
			Case "/!"
			x=StrIndexOf(wiki, "/!", x+1)+2
			
			
			
			Case "/h" 'HTML
			wikiTagStart=x
			wikiTagEnd=StrIndexOf(wiki,"/h",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & WikiSubString 
			Case "/c" 'Code
			wikiTagStart=x
			wikiTagEnd=StrIndexOf(wiki,"/c",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<code>" & WikiSubString & "</code>"
			Case "/$" 'Image
			wikiTagStart=x
			wikiTagEnd=StrIndexOf(wiki,"/$",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
		
			If StrIndexOf(wikiSubString,"?", 1) > -1 Then
				x=StrIndexOf(wikiSubString, "?",1)
				ImageParameterFlag=True
				ImageParameter=SubString(wikiSubString,x+1,StrLength(wikiSubstring)-x)
				WikiSubString=SubString(wikiSubString,0,x)
				'msgbox("Image=" & wikiSubString & crlf & "Parameter=" & ImageParameter)
			Else
				ImageParameterFlag=False
			End If
		
			x=WikiTagEnd+1
			' HtmStr=HtmStr & "<img src='file://" & wikiDir &  WikiSubString & "'>"
		
			HtmStr=HtmStr & "<img src='file://" & Main.wikiDir & wikiSubString & "'"
			If ImageParameterFlag=True Then
				HtmStr=HtmStr & " width='" & ImageParameter & "%' height='" & ImageParameter & "%'"
			End If
			HtmStr=HtmStr & ">"
		
		
			Case "/t" 'Table
			wikiTagStart=x
			wikiTagEnd=StrIndexOf(wiki,"/t",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			'Msgbox(wikisubstring)
			'WikiSubString=StrReplace(WikiSubString,"|","</td><td>")
			WikiSubString=StrReplace(WikiSubString,":","</td><td>")
			WikiSubString=StrReplace(WikiSubString, Chr(13),"</td></tr><tr><td>")
			'Msgbox(wikiSubstring)
			
			HtmStr=HtmStr & "<table border=1><tr><td>" & WikiSubString & "</tr></table>"
			Case "/l" 'List
			wikiTagStart=x
			wikiTagEnd=StrIndexOf(wiki,"/l",x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			
			If StrIndexOf(wikiSubString,"#",0) = -1 Then 
			listType="UL" 
			Else 
			listType="OL"
			End If
			wikiSubString=StrReplace(wikiSubString,Chr(13),"</li>")
			wikiSubString=StrReplace(WikiSubString,"#","<li>")
			wikiSubString=StrReplace(WikiSubString,"-","<li>")
			wikiSubString="<" & listType & ">" & wikiSubString & "</" & listType & ">"
			'Msgbox(wikiSubString)
			HtmStr=HtmStr & wikiSubString
			
			
			' These require a CR to close the tag
			Case "/_"  'horizontal line
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/_",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<hr>"
			Case "/&"  'include file
			wikiTagStart=x
								'wikiTagEnd=StrIndexOf(wiki,"/_",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
								'Msgbox(wikiSubString & " " & currentpage & " " & validateURL(web.NavigatingURL))
'''''Commented out for know until moduling is improved
'			If WikiSubString = Main.currentpage OR wikisubstring=validateURL(web.NavigatingURL) Then
'			Msgbox("Cannot use current page as a header into itself!")
'			Else
'			tempPage=currentPage
'				HtmStr=HtmStr & ReadWikiFile(wikiSubString)
'			currentPage=tempPage
'			End If
''''''''
			
			Case "/e" 'print the escape/slash character
			HtmStr=HtmStr & SubString(wiki, x+2,1)
			x=x+2
			
			Case "/y" 
			HtmStr=HtmStr&"<img src='file://" & AppPath & "/images/y.gif'>"
			x=x+2
			Case "/n"
			HtmStr=HtmStr & "<img src='file://" & AppPath & "/images/n.gif'>"
			x=x+2
		
			Case "/d"
			HtmStr=HtmStr & Date(Now) & " " & Time(Now)
			x=x+2
		
			Case "/1" 'heading
			If StrIndexOf("0123456789", SubString(wiki,x,1),0) > -1 OR (x > 1 AND StrIndexOf("0123456789", SubString(wiki,x-1,1),0) > -1) Then
				HtmStr=HtmStr& wikiTag
				x=x+1
			Else
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/1",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<h1>" & WikiSubString & "</h1>"
			End If
			
			Case "/2" 'heading
			If StrIndexOf("0123456789", SubString(wiki,x,1),0) > -1 OR (x > 1 AND StrIndexOf("0123456789", SubString(wiki,x-1,1),0) > -1) Then
				HtmStr=HtmStr& wikiTag
				x=x+1
			Else
			
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/1",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<h1>" & WikiSubString & "</h1>"
			End If
			
			Case "/3" 'heading
			If StrIndexOf("0123456789", SubString(wiki,x,1),0) > -1 OR (x > 1 AND StrIndexOf("0123456789", SubString(wiki,x-1,1),0) > -1) Then
				HtmStr=HtmStr& wikiTag
				x=x+1
			Else
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/3",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<h3>" & WikiSubString & "</h3>"
			End If
			
			Case "/4" 'heading
			If StrIndexOf("0123456789", SubString(wiki,x,1),0) > -1 OR (x > 1 AND StrIndexOf("0123456789", SubString(wiki,x-1,1),0) > -1) Then
				HtmStr=HtmStr& wikiTag
				x=x+1
			Else
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/4",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<h4>" & WikiSubString & "</h4>"
			End If
			
			Case "/5" 'heading
			If StrIndexOf("0123456789", SubString(wiki,x,1),0) > -1 OR (x > 1 AND StrIndexOf("0123456789", SubString(wiki,x-1,1),0) > -1) Then
				HtmStr=HtmStr& wikiTag
				x=x+1
			Else
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/5",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<h5>" & WikiSubString & "</h5>"
			End If
			
			Case "/6" 'heading
			If StrIndexOf("0123456789", SubString(wiki,x,1),0) > -1 OR (x > 0 AND StrIndexOf("0123456789", SubString(wiki,x-1,1),0) > -1) Then
				HtmStr=HtmStr& wikiTag
				x=x+1
			Else
			wikiTagStart=x
			'wikiTagEnd=StrIndexOf(wiki,"/6",x+1)
			wikiTagEnd=StrIndexOf(wiki,Chr(13),x+1)
			WikiSubstring=SubString(wiki,wikiTagStart+2,(wikiTagEnd)-(wikiTagStart)-2)
			x=WikiTagEnd+1
			HtmStr=HtmStr & "<h6>" & WikiSubString & "</h6>"
			End If
			
			Case "/*"
			HtmStr=HtmStr&"<img src='file://" & AppPath & "/images/banner.jpg'>"
			x=x+2
			
			Case "/-"
			HtmStr=HtmStr&"<img src='file://" & AppPath & "/images/hbar.jpg'>"
			x=x+2
			
			Case Else
			
			End Select
	End If		
    
    'Msgbox("Tag: " & wikiTag & crlf & "Substring: " & wikiSubString & crlf & "Start: " & wikiTagStart & crlf & "End: " & wikiTagEnd)
   'Else If SubString(wiki,x,1)=Chr(13) Then HtmStr=HtmStr & "<br>"
   
   Else
   
   HtmStr=HtmStr & SubString(wiki,x,1)
  
   End If
 
 Next
 
 
 
 HtmStr=HtmStr & "</body></html>"
 'Msgbox(HtmStr)
 Return Htmstr
 
WikiParseError:
 If debugMode=True Then
 ' Msgbox("Warning! syntax and/or parser error.")
 	HtmStr=HtmStr & CRLF & "Warning: syntax and/or parser error." & "</body></html>"
 Else
 	HtmStr=HtmStr & "</body></html>"
 End If
 
 Return HtmStr
End Sub